#! /bin/bash

# questo scipt serve per creare una animazione di mazinga 

# controllo se devo pulire la directory
if [[ $1 == "clean" ]]
then
	# pulisco il file esecutivo creato
	make clean
	rm -f Makefile
	# cancello tutti i file md , arg  vw e ani creati 
	rm -f *.md
	rm -f *.arg
	rm -f *.vw 
	rm -f video.ani
	rm -f video.sta
	rm -f *.hr
	rm -f video.hra
	exit 0
fi	

tot_frame=100

frame_aerea=25
frame_spalle_mazinga=25
frame_figura_intera=22
frame_atterraggio=28

# creo i file .md
xmkmf
make clean
make
# sposto i file del punto di vista e di argomento
cp file_vw_arg/video.arg video.arg

# copio i file del punto di vista per quanti frame devono essere utilizzati
var=0
while [[ $var -lt $frame_aerea ]]
do
	cp file_vw_arg/aerea.vw aerea$var.vw
	var=`expr $var + 1`
done
var=0
while [[ $var -lt $frame_spalle_mazinga ]]
do
	cp file_vw_arg/spalle_mazinga.vw spalle_mazinga$var.vw
	var=`expr $var + 1`
done
var=0
while [[ $var -lt $frame_figura_intera ]]
do
	cp file_vw_arg/figura_intera.vw figura_intera$var.vw
	var=`expr $var + 1`
done
var=0
while [[ $var -lt $frame_atterraggio ]]
do
	cp file_vw_arg/atterraggio.vw atterraggio$var.vw
	var=`expr $var + 1`
done

# cancello un eventuale file precedente
rm -f video.ani
#creo il file ani
echo video.ani >> video.ani
echo $tot_frame >> video.ani

#per ogni riga indico il file arg che è sempre lo stesso e il file appropriato vw
global=0
local=0
state="aerea"
while [[ $var -lt $tot_frame ]]
do
	if  [[ $state == "aerea" ]]
	then
		echo $global video$global.md aerea$local.vw video.arg >> video.ani
		# controllo se devo passare alla prossima inquadratura
		local=`expr $local + 1`
		if [[ $local == $frame_aerea ]]
		then
			# azzero il contatore per il prossimo stato
			local=0
			state="spalle_mazinga"
			# mando avanti global per continuare nello stesso ciclo di while
			global=`expr $global + 1`		
		fi
	fi
	if  [[ $state == "spalle_mazinga" ]]
	then
		echo $global video$global.md spalle_mazinga$local.vw video.arg >> video.ani
		local=`expr $local + 1`
		if [[ $local == $frame_spalle_mazinga ]]
		then
			local=0
			state="figura_intera"
			global=`expr $global + 1`		
		fi
	fi
	if  [[ $state == "figura_intera" ]]
	then
		echo $global video$global.md figura_intera$local.vw video.arg >> video.ani
		local=`expr $local + 1`
		if [[ $local == $frame_figura_intera ]]
		then
			local=0
			state="atterraggio"
			global=`expr $global + 1`		
		fi
	fi

	if  [[ $state == "atterraggio" ]]
	then
		echo $global video$global.md atterraggio$local.vw video.arg >> video.ani
		local=`expr $local + 1`
		if [[ $local == $frame_atterraggio ]]
		then
			# ho finito di scrivere il file ani
			echo "" >> video.ani
			exit 0
		fi
	fi
	# mando avanti il conttore del while
	global=`expr $global + 1`
done

