#include "../modelli/mazinga/mazinga.e"
#include "../modelli/Taj-Mahl/TajMahal.e"
#include "../modelli/sfondo/sfondo.e"
#include "../modelli/Enterprise/enterprise.e"

#include "descriptor/descriptor.h"
#include <stdio.h>

/* costante indicante i frame totali del video */
# define TOTALE_FRAMES (int)100

/* costante indicante i frame in cui l' enterprise è ferma in aria */
#define STOP_VOLO_FRAMES (int)2

/* costante indicante il numero di frame utilizzati per la resa fino al volo dell' enterprise */
#define VOLO_FRAMES (int)70

/* costante indicante il numero di frame utilizzati per la resa fino all' atterraggio dell' enterprise */
#define ATTERRAGGIO_FRAMES (int)22

/* posizione iniziale e finale dell' enterprise */
#define START_X (float)20.0
#define START_Y (float)0.0
#define START_Z (float)4.0

#define END_X (float)7.0
#define END_Y (float)0.0
#define END_Z (float)3.0

/* posizione d' atterraggio */
#define ATTERRAGGIO_X (float)7.0
#define	ATTERRAGGIO_Y (float)0.0
#define ATTERRAGGIO_Z (float)1.2

/* definisco gli stati in cui si trova l' astronamve */
#define VOLO 				(int)0
#define STOP_VOLO 			(int)1
#define ATTERRAGGIO 		(int)2
#define STOP_ATTERRAGGIO	(int)3

int main(){
	ITEM scena ;
	/* creo le strutture da rendere */
	mazinga *maz ;
	sfondo *sfo ;
	ITEM *taj , *enter ;
	maz = new_mazinga( "mazinga" , "../modelli/mazinga" ) ;
	sfo = new_sfondo( "sfondo" , "../modelli/sfondo" ) ;
	taj = new_tajmahal( "../modelli/Taj-Mahl" ) ;
	enter = new_enterprise( "../modelli/Enterprise" ) ;
	/* Sfondo e Luci */
	set_background(1.0, 1.0, 1.0, TRUE);
	set_ambient_light(1.0, 1.0, 1.0, 1.0);
	create_point_light(16.0, 0.0, 10.0,1.0, 1.0, 1.0,1.0, 0.0, "Point-Light");
	/* ridimensiono le figure */
	/* dispongo il mazinga davanti al tajmahal */
	set_translate( *taj , 2.0, 0.0, 0.0 );
	set_scale(maz->list, 0.2,0.2, 0.2);
	set_translate(maz->list, 5.0, 0.0, 1.2 );
	/* dispongo l' enterprise */
	set_translate( *enter , START_X , START_Y , START_Z );
	/* caricamento gli oggetti nella scena */
	scena = create_list(maz->list, "Scena");
	scena = insert_in_list( scena , sfo->list ) ;
	scena = insert_in_list( scena , *taj ) ;
	scena = insert_in_list( scena , *enter ) ;
	/* rendo la scena */
	{
		int i , frames , state ;
		/* trovo di quanto deve avanzare l' enterprise per ogni frame */
		float volo_x , volo_y , volo_z ;
		float terra_x , terra_y , terra_z ;
		volo_x = ( END_X - START_X ) / VOLO_FRAMES ;
		volo_y = ( END_Y - START_Y ) / VOLO_FRAMES ;
		volo_z = ( END_Z - START_Z ) / VOLO_FRAMES ;
		terra_x = ( ATTERRAGGIO_X - END_X ) / ATTERRAGGIO_FRAMES ;
		terra_y = ( ATTERRAGGIO_Y - END_Y ) / ATTERRAGGIO_FRAMES ;
		terra_z = ( ATTERRAGGIO_Z - END_Z ) / ATTERRAGGIO_FRAMES ;
		/* conto i frame delle azioni */
		frames = 0 ;
		/* conto lo stato delle azioni */
		state = VOLO ;
		for ( i = 0 ; i < TOTALE_FRAMES ; i++ ){
			save_scene_ani( TOTALE_FRAMES , "video.ani" , "video" , "video" , scena ) ;
			/* controllo lo stato in cui sono per muovere l' enterprise */
			switch( state )
			{
				case VOLO :
				{
					set_translate( *enter , volo_x , volo_y , volo_z ) ;
					frames++ ;
					/* controllo se ho finito la fase del volo */
					if ( frames == VOLO_FRAMES ) {
						/* cambio stato */
						state = STOP_VOLO ;
						/* azzero il contatore dei frame */
						frames = 0 ;
					}
					break ;
				} ;
				case STOP_VOLO :
				{
					frames++ ;
					/* controllo se ho finito la fase del volo */
					if ( frames == STOP_VOLO_FRAMES ) {
						/* cambio stato */
						state = ATTERRAGGIO ;
						/* azzero il contatore dei frame */
						frames = 0 ;
					}
					break ;
				} ;
				case ATTERRAGGIO :
				{
					set_translate( *enter , terra_x , terra_y , terra_z );
					frames++ ;
					/* controllo se ho finito la fase del volo */
					if ( frames == ATTERRAGGIO_FRAMES ) {
						/* cambio stato */
						state = STOP_ATTERRAGGIO ;
						/* azzero il contatore dei frame */
						frames = 0 ;
					}
					break ;
				} ;
				case STOP_ATTERRAGGIO :
				default :
				{
					/* devo solo aspettare che il ciclo finisca */
					break ;
				}	
			}
		}
	}
	return 0 ;
}
