#ifndef __ENTERPRISE_E__
#define __ENTERPRISE_E__

/* 
	MODULO PER LA GESTIONE DEL MODELLO DELL' ENTERPRISE , QUESTO MODULO È  NON RIENTRANTE , 
	QUINDI IL COSTRUTTORE RESTITUISCE SEMPRE IL PUNTATORE ALLO STESSO OGGETTO
*/

#include "descriptor/descriptor.h"

/* costruttore , restituisce la radice della struttura per le trasformazioni geometriche */
/* come input richiede il path della libreria corrente */
ITEM* new_enterprise( char* path ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../common/utilities.e" /* read_dir_obj */

/* flag che indica se l' enterprise è stata inizializzata oppure no */
static int bool_enterprise_inizialized = 0 ;

/* struttura non rientrante */
static	ITEM enterprise;
static	ITEM bianco, blu, giallo, rosso, grigio;
static	ITEM scafo, *antenna, calotte, fasce, *anello;

ITEM* new_enterprise( char* path ){
	char *s_path ;
	/* controllo se ho gia inizializzato l' oggetto */
	if ( bool_enterprise_inizialized == 1 ) return &enterprise ;
	/* non ho ancora inizializzato */
	bool_enterprise_inizialized = 1 ;
	/* trovo i path verso la sottodirectory s */
	s_path = concat_dir( path , "superfici" ) ;

	bianco = create_attribute("bianco");
	set_color(bianco,0.3,0.3,0.3,0.1,0.8);
	set_reflectivity(bianco,0.3,2);

	giallo = create_attribute("giallo");
	set_color(giallo,0.68,0.86,0.1,0.5,0.5);
	set_reflectivity(giallo,0.24,2);

	rosso = create_attribute("rosso");
	set_color(rosso,1,0,0.5,0.5,0.5);
	set_reflectivity(rosso,0,10);

	blu = create_attribute("blu");
	set_color(blu,0,0,1,0.5,0.5);
	set_reflectivity(blu,0.4,9);

	grigio = create_attribute("grgio");
	set_color(grigio,0.4,0.4,0.4,0.5,0.5);
	set_reflectivity(blu,0.4,9);

	scafo = read_dir_obj("scafo.obj", s_path , "scafo");
	fasce = read_dir_obj("fasce.obj", s_path , "fasce");
	calotte = read_dir_obj("calotte.obj", s_path , "calotte");
	antenna = get_surface( "superfici/antenna2.db" , path ) ;
	anello = get_surface( "superfici/anello.db" , path ) ;

	set_attribute(*antenna, giallo);
	set_attribute(scafo, bianco);
	set_attribute(fasce, blu);
	set_attribute(calotte, rosso);
	set_attribute(*anello, grigio);

	enterprise = create_list(scafo, "enterprise");
	enterprise = insert_in_list(enterprise, fasce);
	enterprise = insert_in_list(enterprise, calotte);
	enterprise = insert_in_list(enterprise, *antenna);
	enterprise = insert_in_list(enterprise, *anello);

	/* libero la stringa del path */
	free( s_path ) ;
	return &enterprise ;
}

#endif
