/* 
	MODULO DI TEST DELLE UTILITIES 
*/

#include "utilities.e"

#include <stdio.h>

void test_concat(){
	/* concateno due stringhe col delimitatiore */
	char* ris ;
	ris = concat( "xcmodel" , "grafica" , "_" ) ;
	printf( "ho concatenato la stringa |%s|\n" , ris ) ;
}

void test_get_surface(){
	ITEM *it , it_attr , scena ;
	/* setto luce e colore di sfondo */
	set_background(1.0, 1.0, 1.0, TRUE);
	set_ambient_light(1.0, 1.0, 1.0, 1.0);
	
	create_point_light(3.0, 1.5, 0.5,		    
					   1.0, 1.0, 1.0,
		1.0, 0.0, "Point-Light");
	/* leggo il file di superficie */
	it = get_surface( "cono_s.db" , "cono" ) ;
	/* ottengo un attributo e lo colego alla superficie */
	it_attr = create_attribute("attr");
	set_color(it_attr,1.0,1.0,0.0,0.3,0.7);
	set_attribute( *it , it_attr );
	/* costruisco la scena */
	scena = create_list( *it, "Scena");
	save_scene("test_get_surface.md", "scena", scena);
}

void test_read_dir_obj() {
	ITEM list ;
	/* leggo la superficie cono */
	list = read_dir_obj( "LIST_cono_s.obj", "cono" , "list" ) ;
	/* setto luce e colore di sfondo */
	set_background(1.0, 1.0, 1.0, TRUE);
	set_ambient_light(1.0, 1.0, 1.0, 1.0);
	
	create_point_light(3.0, 1.5, 0.5,		    
					   1.0, 1.0, 1.0,
		1.0, 0.0, "Point-Light");
	/* costruisco la scena */
	save_scene("test_read_dir_obj.md", "scena", list);
}

int main(){
	test_concat() ;
	test_get_surface() ;
	test_read_dir_obj() ;
	return 0 ;
}

