#! /bin/bash

# questo script fa una statistica di quanti file sono stati creati nella directory corrente 
# e nelle relative sottodirectory , dividendo in file per xcurv ( file c ) file di curve 3d per xsurf
# ( 3c ) e file di superfici generate con xsurf ( s ) 
# la statistica viene poi stampata sullo standard input
 
source tempfile.sh

# creo tre file temporanei e ci inserisco tutti i path dei file da trovare
temp_c=`tempfile`
temp_3c=`tempfile`
temp_s=`tempfile`

find . -type f -name "*_c.db" >> $temp_c
find . -type f -name "*_3c.db" >> $temp_3c
find . -type f -name "*_s.db" >> $temp_s

# conto le righe non vuote dei file temporanei e quindi il numero dei moduli creati
tot_c=`grep --count --invert-match "^$" $temp_c`
tot_3c=`grep --count --invert-match "^$" $temp_3c`
tot_s=`grep --count --invert-match "^$" $temp_s`

#stampo i risultati della statistica 
echo "Nella cartella $PWD e nelle sottocartelle sono presenti :"
echo "Totale file c : " $tot_c
echo "Totale file 3c : " $tot_3c 
echo "Totale file s : " $tot_s
echo ""

# cancello i file temporanei 
deleteALLtempfile

