#! /bin/bash
 
# questo file crea a partire dalla directory corrente per tutte le sottodirectory dei file riassuntivi 
# obj leggibili da XCSurf per le cartelle 3c ( contenente i file di curve tridimensionali ) e per le 
# cartelle s ( conrtenenti le superfici ) . Siccome sono dei file leggibili da XCSurf , devono essere 
# inseriti nella cartella interessata 

source tempfile.sh

# trovo l' indirizzo di tutte le cartelle in cui fare il file riassuntivo e li metto in un file
# posso metterli in uno stesso file perche il formato del file obj è lo stesso
temp_3c_s=`tempfile`

find . -type d -name "3c" >> $temp_3c_s
find . -type d -name "s" >> $temp_3c_s

#salvo la directory corrente
inizial_dir=$PWD

#entro in tutte le directory e costruisco il file riassuntivo 
for directory in `cat $temp_3c_s`
do
	# costruisco il nome del file obj , composto dalla parent directory della cartella 3c o s , poi 
	# dal suffisso list e l' indicazione di 3c o s
	file_type=`basename $directory`
	parent_dir=`dirname $directory`
	parent_name=`basename $parent_dir`
	obj_name=`echo -n "LIST_" ; echo -n $parent_name ; echo -n _ ; echo -n $file_type ; echo -n ".obj"`
	# ho costruito il nome del .obj , costruisco il suo percorso assoluto
	obj=`echo -n $directory ; echo -n "/" ; echo $obj_name`
	# se esiste gia questo file lo rimuovo per metterne uno piu aggiornato
	rm -f $obj
	# trovo l' estensione da cercare nella directory del momento
	ext=`echo -n "*_" ; echo -n $file_type ; echo -n ".db"`
	# creo un file temporaneo e ci piazzo i file da inserire nella lista obj
	temp_list=`tempfile`
	find $directory -maxdepth 1 -name "$ext" >> $temp_list
	# conto quanti file ho nella directory 
	tot_file=`grep --count --invert-match "^$" $temp_list`
	# costruisco il file se solo ho degli elementi da listare 
	if [[ $tot_file > '0' ]]
	then
		# costruisco il file e ci piazzo le informazioni del suo nome al suo interno
		echo "FILENAME :" $obj_name >> $obj
		#inserisco il numero trovato nel file .obj
		echo $tot_file >> $obj
		#inserisco i nomi dei file nella lista temporanea in .obj
		for name in `cat $temp_list`
		do
			echo `basename $name` >> $obj
		done
	fi
done

# cancello i file temporanei 
deleteALLtempfile

