#ifndef __BRACCIA_INFERIORI_E__
#define __BRACCIA_INFERIORI_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELLE BRACCIA INFERIORI
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_braccio_inf_dx = "s/braccio_inf_dx_s.db" ;
char* path_braccio_inf_sx = "s/braccio_inf_sx_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*braccio_inf_dx ,
 			*braccio_inf_sx ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} braccia_inf ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
braccia_inf* new_braccia_inf( char *name , char *path , ITEM *attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
braccia_inf* new_braccia_inf( char *name , char *path , ITEM *attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		braccia_inf* new ;
		new = malloc( sizeof ( braccia_inf )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->braccio_inf_dx = get_surface( path_braccio_inf_dx , path ) ;
		new->braccio_inf_sx = get_surface( path_braccio_inf_sx , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->braccio_inf_dx), *attr);
		set_attribute( *(new->braccio_inf_sx), *attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->braccio_inf_dx), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->braccio_inf_sx) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 

