#ifndef __DITO_E__
#define __DITO_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DEL DITO DELLA MANO
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_falange_down = "s/falange_down_s.db" ;
char* path_falange_mid = "s/falange_mid_s.db" ;
char* path_falange_up = "s/falange_up_s.db" ;
char* path_nocca = "s/nocca_s.db" ;
char* path_unghia = "s/unghia_s.db" ;
char* path_raccordo_up = "s/raccordo_up_s.db" ;
char* path_raccordo_down = "s/raccordo_down_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*falange_down ,
			*falange_mid ,
			*falange_up ,
			*nocca ,
			*unghia ,
			*raccordo_up ,
			*raccordo_down ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} dito ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
dito* new_dito( char *name , char *path , ITEM *dito_attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
dito* new_dito( char *name , char *path , ITEM *dito_attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) ||( dito_attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		dito* new ;
		new = malloc( sizeof ( dito )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->falange_down = get_surface( path_falange_down , path ) ;
		new->falange_mid = get_surface( path_falange_mid , path ) ;
		new->falange_up = get_surface( path_falange_up , path ) ;
		new->nocca = get_surface( path_nocca , path ) ;
		new->unghia = get_surface( path_unghia , path ) ;
		new->raccordo_up = get_surface( path_raccordo_up , path ) ;
		new->raccordo_down = get_surface( path_raccordo_down , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->falange_down), *dito_attr);
		set_attribute( *(new->falange_mid), *dito_attr);
		set_attribute( *(new->falange_up), *dito_attr);
		set_attribute( *(new->nocca), *dito_attr);
		set_attribute( *(new->unghia), *dito_attr);
		set_attribute( *(new->raccordo_up), *dito_attr);
		set_attribute( *(new->raccordo_down), *dito_attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->falange_down), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->falange_mid) ) ;
			new->list = insert_in_list( new->list , *(new->falange_up) ) ;
			new->list = insert_in_list( new->list , *(new->nocca) ) ;
			new->list = insert_in_list( new->list , *(new->unghia) ) ;
			new->list = insert_in_list( new->list , *(new->raccordo_up) ) ;
			new->list = insert_in_list( new->list , *(new->raccordo_down) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 

