#ifndef __SPALLE_E__
#define __SPALLE_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELLE SPALLE
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_spalla_dx = "s/spalla_dx_s.db" ;
char* path_spalla_sx = "s/spalla_sx_s.db" ;


/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*dx ,
 			*sx ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} spalle ;

/* funzione che crea una nuova struttura spalle e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
spalle* new_spalle( char *name , char *path , ITEM *attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura spalle e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
spalle* new_spalle( char *name , char *path , ITEM *attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		spalle* new ;
		new = malloc( sizeof ( spalle )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->dx = get_surface( path_spalla_dx , path ) ;
		new->sx = get_surface( path_spalla_sx , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->dx), *attr);
		set_attribute( *(new->sx), *attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->dx), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->sx) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 

