#ifndef __BACINO_E__
#define __BACINO_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DEL BACINO
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_cintura = "s/cintura_s.db" ;
char* path_cavallo = "s/cavallo_s.db" ;


/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*cintura , 
 			*cavallo ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} bacino ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
bacino* new_bacino( char *name , char *path , ITEM *attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
bacino* new_bacino( char *name , char *path , ITEM *attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		bacino* new ;
		new = malloc( sizeof ( bacino )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->cintura = get_surface( path_cintura , path ) ;
		new->cavallo = get_surface( path_cavallo , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->cintura), *attr);
		set_attribute( *(new->cavallo), *attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->cintura ), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->cavallo) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 

