#ifndef __CORPO_E__
#define __CORPO_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELLA CORPO
*/

#include "descriptor/descriptor.h"

/* sottostrutture */
#include "torace/torace.e"
#include "v/v.e"
#include "addome/addome.e"
#include "bacino/bacino.e"

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* sottostrutture */
	torace* tor ;
	v* v ;
	addome* add ;
	bacino* bac ;
	/* oggetto ITEM che racchiude gli oggetti item delle superfici 
	delle sottostrutture per applicare le trasformazioni spaziali */
	ITEM list ;
} corpo ;

/* funzione che crea una nuova struttura corpo e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
corpo* new_corpo( char *name , char *path , ITEM *corazza_a , ITEM *v_a , ITEM *addome_a ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura corpo e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
corpo* new_corpo( char *name , char *path , ITEM *corazza_a , ITEM *v_a , ITEM *addome_a ) {
	/* controllo i valori di input */
	 if (( name == NULL ) || ( path == NULL ) || 
		( corazza_a == NULL ) || ( v_a == NULL ) || ( addome_a == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		corpo* new ;
		new = malloc( sizeof ( corpo )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		{
			char *path_tor , *path_v , *path_bac , *path_add ;	
			/* ricavo gli indirizzi delle sottostrutture */
			path_tor = concat_dir( path , "torace" ) ;
			path_add = concat_dir( path , "addome" ) ;
			path_bac = concat_dir( path , "bacino" ) ;
			path_v = concat_dir( path , "v" ) ;
			/* ricavo le sottostrutture */
			new->tor = new_torace( "torace" , path_tor , corazza_a ) ;
			new->v = new_v( "v" , path_v , v_a ) ;
			new->add = new_addome( "addome" , path_add , addome_a ) ;
			new->bac = new_bacino( "bacino" , path_bac , corazza_a ) ;
			/* libero la memoria delle stringhe */
			free(path_tor ) ; free(path_v ) ;
			free(path_bac ) ; free(path_add ) ;
		}
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( new->tor->list , name_lista ) ;
			new->list = insert_in_list( new->list , new->v->list ) ;
			new->list = insert_in_list( new->list , new->add->list ) ;
			new->list = insert_in_list( new->list , new->bac->list ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 
