#ifndef __TORACE_E__
#define __TORACE_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DEL TORACE
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_torace_dx = "s/torace_dx_s.db" ;
char* path_torace_sx = "s/torace_sx_s.db" ;
char* path_chiudi_collo_dx = "s/chiudi_collo_dx_s.db" ;
char* path_chiudi_collo_sx = "s/chiudi_collo_sx_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*torace_dx , 
			*torace_sx ,
   			*chiudi_collo_dx ,
	  		*chiudi_collo_sx ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} torace ;

/* funzione che crea una nuova struttura torace e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
torace* new_torace( char *name , char *path , ITEM *attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura torace e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
torace* new_torace( char *name , char *path , ITEM *attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		torace* new ;
		new = malloc( sizeof ( torace )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->torace_dx = get_surface( path_torace_dx , path ) ;
		new->torace_sx = get_surface( path_torace_sx , path ) ;
		new->chiudi_collo_dx = get_surface( path_chiudi_collo_dx , path ) ;
		new->chiudi_collo_sx = get_surface( path_chiudi_collo_sx , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->torace_dx) , *attr);
		set_attribute( *(new->torace_sx), *attr);
		set_attribute( *(new->chiudi_collo_dx), *attr);
		set_attribute( *(new->chiudi_collo_sx), *attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->torace_dx ), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->torace_sx) ) ;
			new->list = insert_in_list( new->list , *(new->chiudi_collo_dx) ) ;
			new->list = insert_in_list( new->list , *(new->chiudi_collo_sx) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 
