#ifndef __V_E__
#define __V_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELLA V SUL TORACE
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_v_bordo_dx = "s/v_bordo_dx_s.db" ;
char* path_v_bordo_sx = "s/v_bordo_sx_s.db" ;
char* path_v_fulmine_ext_dx = "s/v_fulmine_ext_dx_s.db" ;
char* path_v_fulmine_ext_sx = "s/v_fulmine_ext_sx_s.db" ;
char* path_v_fulmine_int_dx = "s/v_fulmine_int_dx_s.db" ;
char* path_v_fulmine_int_sx = "s/v_fulmine_int_sx_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*v_bordo_dx , 
 			*v_bordo_sx ,
			*v_fulmine_ext_dx ,
 			*v_fulmine_ext_sx ,
			*v_fulmine_int_dx ,
 			*v_fulmine_int_sx ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} v ;

/* funzione che crea una nuova struttura v e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
v* new_v( char *name , char *path , ITEM *attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura v e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
v* new_v( char *name , char *path , ITEM *attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		v* new ;
		new = malloc( sizeof ( v )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->v_bordo_dx = get_surface( path_v_bordo_dx , path ) ;
		new->v_bordo_sx = get_surface( path_v_bordo_sx , path ) ;
		new->v_fulmine_ext_dx = get_surface( path_v_fulmine_ext_dx , path ) ;
		new->v_fulmine_ext_sx = get_surface( path_v_fulmine_ext_sx , path ) ;
		new->v_fulmine_int_dx = get_surface( path_v_fulmine_int_dx , path ) ;
		new->v_fulmine_int_sx = get_surface( path_v_fulmine_int_sx , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->v_bordo_dx), *attr);
		set_attribute( *(new->v_bordo_sx), *attr);
		set_attribute( *(new->v_fulmine_ext_dx), *attr);
		set_attribute( *(new->v_fulmine_ext_sx), *attr);
		set_attribute( *(new->v_fulmine_int_dx), *attr);
		set_attribute( *(new->v_fulmine_int_sx), *attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->v_bordo_dx ), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->v_bordo_sx) ) ;
			new->list = insert_in_list( new->list , *(new->v_fulmine_ext_dx) ) ;
			new->list = insert_in_list( new->list , *(new->v_fulmine_ext_sx) ) ;
			new->list = insert_in_list( new->list , *(new->v_fulmine_int_dx) ) ;
			new->list = insert_in_list( new->list , *(new->v_fulmine_int_sx) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 

