#ifndef __GAMBE_E__
#define __GAMBE_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELLE GAMBE
*/

#include "descriptor/descriptor.h"

/* sottostrutture */
#include "gambe_superiori/gambe_superiori.e"
#include "gambe_inferiori/gambe_inferiori.e"
#include "piedi/piedi.e"

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* sottostrutture */
	gambe_sup* sup ;
	gambe_inf* inf ;
	piedi* pie ;
	/* oggetto ITEM che racchiude gli oggetti item delle superfici 
	delle sottostrutture per applicare le trasformazioni spaziali */
	ITEM list ;
} gambe ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
gambe* new_gambe( char *name , char *path , ITEM *giunture_a , ITEM *parte_sup_a , ITEM *parte_inf_a ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
gambe* new_gambe( char *name , char *path , ITEM *giunture_a , ITEM *parte_sup_a , ITEM *parte_inf_a ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) ||
		( giunture_a == NULL ) || ( parte_sup_a == NULL ) || ( parte_inf_a == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		gambe* new ;
		new = malloc( sizeof ( gambe )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		{
			char *path_sup , *path_inf , *path_pie ;	
			/* ricavo gli indirizzi delle sottostrutture */
			path_sup = concat_dir( path , "gambe_superiori" ) ;
			path_inf = concat_dir( path , "gambe_inferiori" ) ;
			path_pie = concat_dir( path , "piedi" ) ;
			/* ricavo le sottostrutture */
			new->sup = new_gambe_sup( "gambe_superiori" , path_sup , parte_sup_a , giunture_a ) ;
			new->inf = new_gambe_inf( "gambe_inferiori" , path_inf , parte_inf_a , giunture_a ) ;
			new->pie = new_piedi( "piedi" , path_pie , parte_inf_a , giunture_a ) ;
			/* libero la memoria delle stringhe */
			free( path_sup ) ;
			free( path_inf ) ;
			free( path_pie ) ;
		}
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( new->sup->list , name_lista ) ;
			new->list = insert_in_list( new->list , new->inf->list ) ;
			new->list = insert_in_list( new->list , new->pie->list ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 
