#ifndef __GAMBE_SUPERIORI_E__
#define __GAMBE_SUPERIORI_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELLE GAMBE SUPERIORI
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_gamba_sup_dx = "s/gamba_sup_dx_s.db" ;
char* path_gamba_sup_sx = "s/gamba_sup_sx_s.db" ;
char* path_ginocchio_dx = "s/ginocchio_dx_s.db" ;
char* path_ginocchio_sx = "s/ginocchio_sx_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*gamba_dx ,
 			*gamba_sx ,
			*ginocchio_dx ,
   			*ginocchio_sx ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} gambe_sup ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
gambe_sup* new_gambe_sup( char *name , char *path , ITEM *gamba_attr , ITEM *ginocchio_attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
gambe_sup* new_gambe_sup( char *name , char *path , ITEM *gamba_attr , ITEM *ginocchio_attr ) {
	/* controllo i valori di input */
if (( name == NULL )||( path == NULL )||( gamba_attr == NULL )||( ginocchio_attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		gambe_sup* new ;
		new = malloc( sizeof ( gambe_sup )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->gamba_dx = get_surface( path_gamba_sup_dx , path ) ;
		new->gamba_sx = get_surface( path_gamba_sup_sx , path ) ;
		new->ginocchio_dx = get_surface( path_ginocchio_dx , path ) ;
		new->ginocchio_sx = get_surface( path_ginocchio_sx , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->gamba_dx), *gamba_attr);
		set_attribute( *(new->gamba_sx), *gamba_attr);
		set_attribute( *(new->ginocchio_dx), *ginocchio_attr);
		set_attribute( *(new->ginocchio_sx), *ginocchio_attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->gamba_dx), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->gamba_sx) ) ;
			new->list = insert_in_list( new->list , *(new->ginocchio_dx) ) ;
			new->list = insert_in_list( new->list , *(new->ginocchio_sx) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 

