#ifndef __MAZINGA_E__
#define __MAZINGA_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DEL MAZINGA , I COLORI SONO IMPOSTATI DI DEFAULT , PER 
	MODIFICARLI BASTA CAMBIARE QUELLI DATI NELLA STRUTTURA MAZINGA 
*/

#include "descriptor/descriptor.h"

/* sottostrutture */
#include "testa/testa.e"
#include "corpo/corpo.e"
#include "gambe/gambe.e"
#include "braccia/braccia.e"

/* indico la struttura contenente tutti gli ITEM */
typedef struct {
	/* sottostrutture */
	testa* tes ;
	corpo* cor ;
	gambe* gam ;
	braccia* bra ;
	/* attributi delle strutture */
	ITEM 	*occhi_a , *corna_a , *viso_a , *maschera_a , *interno_aeratori_a , *saldature_testa_a ,
 			*corazza_a , *v_a , *addome_a , *parte_sup_arti_a , *parte_inf_arti_a , *giunture_a , 
			*jet_pilder_a , *parabrezza_jet_a ;
	/* oggetto ITEM che racchiude gli oggetti item delle superfici 
	delle sottostrutture per applicare le trasformazioni spaziali */
	ITEM list ;
} mazinga ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
mazinga* new_mazinga( char *name , char *path ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
mazinga* new_mazinga( char *name , char *path ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		mazinga* new ;
		new = malloc( sizeof ( mazinga )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* costruisco gli attributi di default */
		new->occhi_a = get_attribute( name , "occhi_a" ) ;
		new->corna_a = get_attribute( name , "corna_a" ) ;
		new->viso_a = get_attribute( name , "viso_a" ) ;
		new->maschera_a = get_attribute( name , "maschera_a" ) ;
		new->interno_aeratori_a = get_attribute( name , "interno_aeratori_a" ) ;
		new->saldature_testa_a = get_attribute( name , "saldature_testa_a" ) ;
		new->corazza_a = get_attribute( name , "corazza_a" ) ;
		new->v_a = get_attribute( name , "v_a" ) ;
		new->addome_a = get_attribute( name , "addome_a" ) ;
		new->parte_sup_arti_a = get_attribute( name , "parte_sup_arti_a" ) ;
		new->parte_inf_arti_a = get_attribute( name , "parte_inf_arti_a" ) ;
		new->giunture_a = get_attribute( name , "giunture_a" ) ;
		new->jet_pilder_a = get_attribute( name , "jet_pilder_a" ) ;
		new->parabrezza_jet_a = get_attribute( name , "parabrezza_jet_a" ) ;
		/* setto gli attributi */
		set_color(*(new->occhi_a),1.0,1.0,0.0,0.3,0.7);
		set_reflectivity(*(new->occhi_a), 0.6, 2.0);
		set_color(*(new->corna_a),1.0,1.0,0.0,0.3,0.7);
		set_reflectivity(*(new->corna_a), 0.6, 2.0);
		set_color(*(new->viso_a),0.0,0.0,1.0,0.3,0.7);
		set_reflectivity(*(new->viso_a), 0.6, 2.0);
		set_color(*(new->maschera_a),0.6,0.6,0.6,0.3,0.7);
		set_reflectivity(*(new->maschera_a), 0.6, 2.0);
		set_color(*(new->saldature_testa_a),0.0,0.0,0.0,0.3,0.7);
		set_reflectivity(*(new->saldature_testa_a), 0.6, 2.0);
		set_color(*(new->interno_aeratori_a),0.0,0.0,0.0,0.3,0.7);
		set_reflectivity(*(new->interno_aeratori_a), 0.6, 2.0);
		set_color(*(new->corazza_a),0.1,0.1,0.1,0.3,0.7);
		set_reflectivity(*(new->corazza_a), 0.6, 2.0);
		set_color(*(new->v_a),1.0,0.0,0.0,0.3,0.7);
		set_reflectivity(*(new->v_a), 0.6, 2.0);
		set_color(*(new->addome_a),0.95,0.95,0.95,0.3,0.7);
		set_reflectivity(*(new->addome_a), 0.6, 2.0);
		set_color(*(new->parte_sup_arti_a),0.95,0.95,0.95,0.3,0.7);
		set_reflectivity(*(new->parte_sup_arti_a), 0.6, 2.0);
		set_color(*(new->parte_inf_arti_a),0.0,0.0,0.5,0.3,0.7);
		set_reflectivity(*(new->parte_inf_arti_a), 0.6, 2.0);
		set_color(*(new->giunture_a),0.1,0.1,0.1,0.3,0.7);
		set_reflectivity(*(new->giunture_a), 0.6, 2.0);
		set_color(*(new->jet_pilder_a),1.0,0.0,0.0,0.3,0.7);
		set_reflectivity(*(new->jet_pilder_a), 0.6, 2.0);
		set_color(*(new->parabrezza_jet_a),0.4,0.4,0.4,0.3,0.7);
		set_reflectivity(*(new->parabrezza_jet_a), 0.6, 2.0);
		{
			char *path_tes , *path_cor , *path_gam , *path_bra ;
			/* ricavo gli indirizzi delle sottostrutture */
			path_tes = concat_dir( path , "testa" ) ;
			path_cor = concat_dir( path , "corpo" ) ;
			path_gam = concat_dir( path , "gambe" ) ;
			path_bra = concat_dir( path , "braccia" ) ;
			/* ricavo le sottostrutture */
			new->tes = new_testa( "testa" , path_tes , new->occhi_a ,new->corna_a ,new->viso_a ,
								  	new->maschera_a , new->saldature_testa_a ,new->interno_aeratori_a ,
		   							new->jet_pilder_a , new->parabrezza_jet_a ) ;
			new->cor = new_corpo( "corpo" , path_cor , new->corazza_a , new->v_a , new->addome_a ) ;
			new->gam = new_gambe( "gambe" , path_gam , new->giunture_a , new->parte_sup_arti_a ,
								  new->parte_inf_arti_a ) ;
			new->bra = new_braccia( "braccia" , path_bra , new->corazza_a , new->giunture_a ,
									new->parte_sup_arti_a , new->parte_inf_arti_a ) ;
			/* libero la memoria delle stringhe */
			free(path_tes ) ; free(path_cor ) ;
			free(path_gam ) ; free(path_bra ) ;
		}
		{
			/* sistemo le proporzioni tra le varie parti */
			/* abbasso la testa */
			set_translate(new->tes->list, 0.0 ,0.0 , -0.17 ) ;
			/* alzo il bacino */
			set_translate(new->cor->bac->list, 0.0 ,0.0 , 0.1 ) ;
		}
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( new->tes->list , name_lista ) ;
			new->list = insert_in_list( new->list , new->cor->list ) ;
 			new->list = insert_in_list( new->list , new->gam->list ) ;
 			new->list = insert_in_list( new->list , new->bra->list ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif
