#ifndef __AERATORE_LATERALE_E__
#define __AERATORE_LATERALE_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELL' AERATORE LATERALE
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_fascia_aeratore_down_dx = "s/fascia_aeratore_down_dx_s.db" ;
char* path_fascia_aeratore_down_sx = "s/fascia_aeratore_down_sx_s.db" ;
char* path_fascia_aeratore_dx_alto = "s/fascia_aeratore_dx_alto_s.db" ;
char* path_fascia_aeratore_dx_basso = "s/fascia_aeratore_dx_basso_s.db" ;
char* path_fascia_aeratore_dx_medio = "s/fascia_aeratore_dx_medio_s.db" ;
char* path_fascia_aeratore_dx_mid_alto = "s/fascia_aeratore_dx_mid_alto_s.db" ;
char* path_fascia_aeratore_dx_mid_basso = "s/fascia_aeratore_dx_mid_basso_s.db" ;
char* path_fascia_aeratore_sx_alto = "s/fascia_aeratore_sx_alto_s.db" ;
char* path_fascia_aeratore_sx_basso = "s/fascia_aeratore_sx_basso_s.db" ;
char* path_fascia_aeratore_sx_medio = "s/fascia_aeratore_sx_medio_s.db" ;
char* path_fascia_aeratore_sx_mid_alto = "s/fascia_aeratore_sx_mid_alto_s.db" ;
char* path_fascia_aeratore_sx_mid_basso = "s/fascia_aeratore_sx_mid_basso_s.db" ;
char* path_fascia_aeratore_up_dx = "s/fascia_aeratore_up_dx_s.db" ;
char* path_fascia_aeratore_up_sx = "s/fascia_aeratore_up_sx_s.db" ;
char* path_parete_down_aeratori = "s/parete_down_aeratori_s.db" ;
char* path_parete_dx_aeratore_alto = "s/parete_dx_aeratore_alto_s.db" ;
char* path_parete_dx_aeratore_basso = "s/parete_dx_aeratore_basso_s.db" ;
char* path_parete_dx_aeratore_mid_alto = "s/parete_dx_aeratore_mid_alto_s.db" ;
char* path_parete_dx_aeratore_mid_basso = "s/parete_dx_aeratore_mid_basso_s.db" ;
char* path_parete_fondo_aeratori_dx = "s/parete_fondo_aeratori_dx_s.db" ;
char* path_parete_fondo_aeratori_sx = "s/parete_fondo_aeratori_sx_s.db" ;
char* path_parete_sx_aeratore_alto = "s/parete_sx_aeratore_alto_s.db" ;
char* path_parete_sx_aeratore_basso = "s/parete_sx_aeratore_basso_s.db" ;
char* path_parete_sx_aeratore_mid_alto = "s/parete_sx_aeratore_mid_alto_s.db" ;
char* path_parete_sx_aeratore_mid_basso = "s/parete_sx_aeratore_mid_basso_s.db" ;
char* path_parete_up_aeratori = "s/parete_up_aeratori_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*fascia_aeratore_down_dx ,
			*fascia_aeratore_down_sx ,
			*fascia_aeratore_dx_alto , 
			*fascia_aeratore_dx_basso ,
			*fascia_aeratore_dx_medio ,
			*fascia_aeratore_dx_mid_alto ,
			*fascia_aeratore_dx_mid_basso ,
			*fascia_aeratore_sx_alto ,
			*fascia_aeratore_sx_basso ,
			*fascia_aeratore_sx_medio ,
			*fascia_aeratore_sx_mid_alto ,
			*fascia_aeratore_sx_mid_basso ,
			*fascia_aeratore_up_dx ,
			*fascia_aeratore_up_sx ,
			*parete_down_aeratori ,
			*parete_dx_aeratore_alto ,
			*parete_dx_aeratore_basso ,
			*parete_dx_aeratore_mid_alto ,
			*parete_dx_aeratore_mid_basso ,
			*parete_fondo_aeratori_dx ,
			*parete_fondo_aeratori_sx ,
			*parete_sx_aeratore_alto ,
			*parete_sx_aeratore_basso ,
			*parete_sx_aeratore_mid_alto ,
			*parete_sx_aeratore_mid_basso ,
			*parete_up_aeratori ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} aeratore_laterale ;

/* funzione che crea una nuova struttura aeratore e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria e gli attributi relativi */
aeratore_laterale* new_aeratore_laterale( char *name , char *path , ITEM *sfondo_attr , ITEM *aeratore_attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */
				 
/* funzione che crea una nuova struttura aeratore e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria e gli attributi relativi */
aeratore_laterale* new_aeratore_laterale( char *name , char *path , ITEM *sfondo_attr , ITEM *aeratore_attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( sfondo_attr == NULL ) || ( aeratore_attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		aeratore_laterale* new ;
		new = malloc( sizeof ( aeratore_laterale )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->fascia_aeratore_down_dx = get_surface( path_fascia_aeratore_down_dx , path ) ;
		new->fascia_aeratore_down_sx = get_surface( path_fascia_aeratore_down_sx , path ) ;
		new->fascia_aeratore_dx_alto = get_surface( path_fascia_aeratore_dx_alto , path ) ;
		new->fascia_aeratore_dx_basso = get_surface( path_fascia_aeratore_dx_basso , path ) ;
		new->fascia_aeratore_dx_medio = get_surface( path_fascia_aeratore_dx_medio , path ) ;
		new->fascia_aeratore_dx_mid_alto = get_surface( path_fascia_aeratore_dx_mid_alto , path ) ;
		new->fascia_aeratore_dx_mid_basso = get_surface( path_fascia_aeratore_dx_mid_basso , path ) ;
		new->fascia_aeratore_sx_alto = get_surface( path_fascia_aeratore_sx_alto , path ) ;
		new->fascia_aeratore_sx_basso = get_surface( path_fascia_aeratore_sx_basso , path ) ;
		new->fascia_aeratore_sx_medio = get_surface( path_fascia_aeratore_sx_medio , path ) ;
		new->fascia_aeratore_sx_mid_alto = get_surface( path_fascia_aeratore_sx_mid_alto , path ) ;
		new->fascia_aeratore_sx_mid_basso = get_surface( path_fascia_aeratore_sx_mid_basso , path ) ;
		new->fascia_aeratore_up_dx = get_surface( path_fascia_aeratore_up_dx , path ) ;
		new->fascia_aeratore_up_sx = get_surface( path_fascia_aeratore_up_sx , path ) ;
		new->parete_down_aeratori = get_surface( path_parete_down_aeratori , path ) ;
		new->parete_dx_aeratore_alto = get_surface( path_parete_dx_aeratore_alto , path ) ;
		new->parete_dx_aeratore_basso = get_surface( path_parete_dx_aeratore_basso , path ) ;
		new->parete_dx_aeratore_mid_alto = get_surface( path_parete_dx_aeratore_mid_alto , path ) ;
		new->parete_dx_aeratore_mid_basso = get_surface( path_parete_dx_aeratore_mid_basso , path ) ;
		new->parete_fondo_aeratori_dx = get_surface( path_parete_fondo_aeratori_dx , path ) ;
		new->parete_fondo_aeratori_sx = get_surface( path_parete_fondo_aeratori_sx , path ) ;
		new->parete_sx_aeratore_alto = get_surface( path_parete_sx_aeratore_alto , path ) ;
		new->parete_sx_aeratore_basso = get_surface( path_parete_sx_aeratore_basso , path ) ;
		new->parete_sx_aeratore_mid_alto = get_surface( path_parete_sx_aeratore_mid_alto , path ) ;
		new->parete_sx_aeratore_mid_basso = get_surface( path_parete_sx_aeratore_mid_basso , path ) ;
		new->parete_up_aeratori = get_surface( path_parete_up_aeratori , path ) ;
		/* setto gli attributi dati */
		set_attribute( *(new->fascia_aeratore_down_dx) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_down_sx) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_dx_alto) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_dx_basso) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_dx_medio) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_dx_mid_alto) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_dx_mid_basso) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_sx_alto) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_sx_basso) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_sx_medio) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_sx_mid_alto) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_sx_mid_basso) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_up_dx) , *aeratore_attr);
		set_attribute( *(new->fascia_aeratore_up_sx) , *aeratore_attr);
		set_attribute( *(new->parete_down_aeratori) , *aeratore_attr);
		set_attribute( *(new->parete_dx_aeratore_alto) , *aeratore_attr);
		set_attribute( *(new->parete_dx_aeratore_basso) , *aeratore_attr);
		set_attribute( *(new->parete_dx_aeratore_mid_alto) , *aeratore_attr);
		set_attribute( *(new->parete_dx_aeratore_mid_basso) , *aeratore_attr);
		set_attribute( *(new->parete_fondo_aeratori_dx) , *sfondo_attr);
		set_attribute( *(new->parete_fondo_aeratori_sx) , *sfondo_attr);
		set_attribute( *(new->parete_sx_aeratore_alto) , *aeratore_attr);
		set_attribute( *(new->parete_sx_aeratore_basso) , *aeratore_attr);
		set_attribute( *(new->parete_sx_aeratore_mid_alto) , *aeratore_attr);
		set_attribute( *(new->parete_sx_aeratore_mid_basso) , *aeratore_attr);
		set_attribute( *(new->parete_up_aeratori) , *aeratore_attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->fascia_aeratore_down_dx ), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_down_sx) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_dx_alto) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_dx_basso) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_dx_medio) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_dx_mid_alto) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_dx_mid_basso) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_sx_alto) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_sx_basso) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_sx_medio) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_sx_mid_alto) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_sx_mid_basso) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_up_dx) ) ;
			new->list = insert_in_list( new->list , *(new->fascia_aeratore_up_sx) ) ;
			new->list = insert_in_list( new->list , *(new->parete_down_aeratori) ) ;
			new->list = insert_in_list( new->list , *(new->parete_dx_aeratore_alto) ) ;
			new->list = insert_in_list( new->list , *(new->parete_dx_aeratore_basso) ) ;
			new->list = insert_in_list( new->list , *(new->parete_dx_aeratore_mid_alto) ) ;
			new->list = insert_in_list( new->list , *(new->parete_dx_aeratore_mid_basso) ) ;
			new->list = insert_in_list( new->list , *(new->parete_fondo_aeratori_dx) ) ;
			new->list = insert_in_list( new->list , *(new->parete_fondo_aeratori_sx) ) ;
			new->list = insert_in_list( new->list , *(new->parete_sx_aeratore_alto) ) ;
			new->list = insert_in_list( new->list , *(new->parete_sx_aeratore_basso) ) ;
			new->list = insert_in_list( new->list , *(new->parete_sx_aeratore_mid_alto) ) ;
			new->list = insert_in_list( new->list , *(new->parete_sx_aeratore_mid_basso) ) ;
			new->list = insert_in_list( new->list , *(new->parete_up_aeratori) ) ;
			free( name_lista ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 
