#ifndef __COLLO_E__
#define __COLLO_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DEL COLLO
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_atlante = "s/atlante_s.db" ;
char* path_collo = "s/collo_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*atlante , 
			*collo ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} collo ;

/* funzione che crea una nuova struttura collo e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
collo* new_collo( char *name , char *path , ITEM *attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */
				 
/* funzione che crea una nuova struttura collo e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
collo* new_collo( char *name , char *path , ITEM *attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		collo* new ;
		new = malloc( sizeof ( collo )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->atlante = get_surface( path_atlante , path ) ;
		new->collo = get_surface( path_collo , path ) ;
		/* imposto gli attributi */
		set_attribute( *(new->atlante) , *attr);
		set_attribute( *(new->collo), *attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->collo ), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->atlante) ) ;
			free( name_lista ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 
