#ifndef __CORONA_FRONTE_E__
#define __CORONA_FRONTE_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELLA CORONA E DELLA FRONTE
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_corona_dx = "s/corona_dx_s.db" ;
char* path_corona_sx = "s/corona_sx_s.db" ;
char* path_fronte_fondo_dx = "s/fronte_fondo_dx_s.db" ;
char* path_fronte_fondo_sx = "s/fronte_fondo_sx_s.db" ;
char* path_fronte_dx = "s/fronte_dx_s.db" ;
char* path_fronte_sx = "s/fronte_sx_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*corona_dx , 
 			*corona_sx , 
			*fronte_fondo_dx , 
 			*fronte_fondo_sx , 
			*fronte_dx , 
 			*fronte_sx ;
	/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} corona_fronte ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
corona_fronte* new_corona_fronte( char *name , char *path , ITEM *attr) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */
				 
/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
corona_fronte* new_corona_fronte( char *name , char *path , ITEM *attr) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		corona_fronte* new ;
		new = malloc( sizeof ( corona_fronte )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->corona_dx = get_surface( path_corona_dx , path ) ;
		new->corona_sx = get_surface( path_corona_sx , path ) ;
		new->fronte_fondo_dx = get_surface( path_fronte_fondo_dx , path ) ;
		new->fronte_fondo_sx = get_surface( path_fronte_fondo_sx , path ) ;
		new->fronte_dx = get_surface( path_fronte_dx , path ) ;
		new->fronte_sx = get_surface( path_fronte_sx , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->corona_dx) , *attr);
		set_attribute( *(new->corona_sx), *attr);
		set_attribute( *(new->fronte_fondo_dx), *attr);
		set_attribute( *(new->fronte_fondo_sx), *attr);
		set_attribute( *(new->fronte_dx), *attr);
		set_attribute( *(new->fronte_sx), *attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->corona_dx ), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->corona_sx) ) ;
			new->list = insert_in_list( new->list , *(new->fronte_fondo_dx) ) ;
			new->list = insert_in_list( new->list , *(new->fronte_fondo_sx) ) ;
			new->list = insert_in_list( new->list , *(new->fronte_dx) ) ;
			new->list = insert_in_list( new->list , *(new->fronte_sx) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 
