#ifndef __INCAVO_JET_PILDER_E__
#define __INCAVO_JET_PILDER_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELL 'INACVO DEL JET PILDER
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_incavo_sopracciglio_dx = "s/sopracciglio_dx_s.db" ;
char* path_incavo_occhio_dx = "s/occhio_dx_s.db" ;
char* path_incavo_sopracciglio_sx = "s/sopracciglio_sx_s.db" ;
char* path_incavo_occhio_sx = "s/occhio_sx_s.db" ;
char* path_incavo_naso = "s/naso_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*sopracciglio_dx , 
 			*occhio_dx , 
			*sopracciglio_sx , 
   			*occhio_sx , 
   			*naso ;
	/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} incavo_jet_pilder ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
incavo_jet_pilder* new_incavo_jet_pilder( char *name , char *path , ITEM *attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */
				 
/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
incavo_jet_pilder* new_incavo_jet_pilder( char *name , char *path , ITEM *attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		incavo_jet_pilder* new ;
		new = malloc( sizeof ( incavo_jet_pilder )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->sopracciglio_dx = get_surface( path_incavo_sopracciglio_dx , path ) ;
		new->occhio_dx = get_surface( path_incavo_occhio_dx , path ) ;
		new->sopracciglio_sx = get_surface( path_incavo_sopracciglio_sx , path ) ;
		new->occhio_sx = get_surface( path_incavo_occhio_sx , path ) ;
		new->naso = get_surface( path_incavo_naso , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->sopracciglio_dx) , *attr);
		set_attribute( *(new->occhio_dx), *attr);
		set_attribute( *(new->sopracciglio_sx), *attr);
		set_attribute( *(new->occhio_sx), *attr);
		set_attribute( *(new->naso), *attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->sopracciglio_dx ), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->occhio_dx) ) ;
			new->list = insert_in_list( new->list , *(new->sopracciglio_sx) ) ;
			new->list = insert_in_list( new->list , *(new->occhio_sx) ) ;
			new->list = insert_in_list( new->list , *(new->naso) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 
