#ifndef __INTERNO_CORONA_E__
#define __INTERNO_CORONA_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DELL' INTERNO DELLA CORONA
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_corona_int_sx = "s/corona_int_sx_s.db" ;
char* path_fulmine_ant_sx = "s/fulmine_ant_sx_s.db" ;
char* path_fulmine_post_sx = "s/fulmine_post_sx_s.db" ;
char* path_corona_int_dx = "s/corona_int_dx_s.db" ;
char* path_fulmine_ant_dx = "s/fulmine_ant_dx_s.db" ;
char* path_fulmine_post_dx = "s/fulmine_post_dx_s.db" ;
char* path_calotta_cranica = "s/calotta_cranica_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*corona_int_sx ,
 			*fulmine_ant_sx ,
			*fulmine_post_sx ,
			*corona_int_dx ,
   			*fulmine_ant_dx ,
   			*fulmine_post_dx ,
	  		*calotta_cranica ;
	/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} interno_corona ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
interno_corona* new_interno_corona( char *name , char *path , ITEM *attr) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */
				 
/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
interno_corona* new_interno_corona( char *name , char *path , ITEM *attr) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		interno_corona* new ;
		new = malloc( sizeof ( interno_corona )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->corona_int_sx = get_surface( path_corona_int_sx , path ) ;
		new->fulmine_ant_sx = get_surface( path_fulmine_ant_sx , path ) ;
		new->fulmine_post_sx = get_surface( path_fulmine_post_sx , path ) ;
		new->corona_int_dx = get_surface( path_corona_int_dx , path ) ;
		new->fulmine_ant_dx = get_surface( path_fulmine_ant_dx , path ) ;
		new->fulmine_post_dx = get_surface( path_fulmine_post_dx , path ) ;
		new->calotta_cranica = get_surface( path_calotta_cranica , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->corona_int_sx) , *attr);
		set_attribute( *(new->fulmine_ant_sx) , *attr);
		set_attribute( *(new->fulmine_post_sx) , *attr);
		set_attribute( *(new->corona_int_dx) , *attr);
		set_attribute( *(new->fulmine_ant_dx) , *attr);
		set_attribute( *(new->fulmine_post_dx) , *attr);
		set_attribute( *(new->calotta_cranica) , *attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->corona_int_sx ), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->fulmine_ant_sx) ) ;
			new->list = insert_in_list( new->list , *(new->fulmine_post_sx) ) ;
			new->list = insert_in_list( new->list , *(new->corona_int_dx) ) ;
			new->list = insert_in_list( new->list , *(new->fulmine_ant_dx) ) ;
			new->list = insert_in_list( new->list , *(new->fulmine_post_dx) ) ;
			new->list = insert_in_list( new->list , *(new->calotta_cranica) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 
