#ifndef __OCCHI_E__
#define __OCCHI_E__

/* 
	MODULO PER LA GESTIONE DELLE SUPERFICI DEGLI OCCHI
*/

#include "descriptor/descriptor.h"

/* percorsi dei file di superficie a partire dalla directory della libreria corrente */
char* path_occhio_bulbo_dx = "s/occhio_bulbo_dx_s.db" ;
char* path_occhio_bulbo_sx = "s/occhio_bulbo_sx_s.db" ;
char* path_occhio_dx = "s/occhio_dx_s.db" ;
char* path_occhio_sx = "s/occhio_sx_s.db" ;

/* indico la struttura contentne tutti gli ITEM */
typedef struct {
	/* singoli oggetti ITEM per le singole superfici */
	ITEM 	*occhio_bulbo_dx , 
			*occhio_bulbo_sx , 
			*occhio_dx , 
			*occhio_sx ;
		/* oggetto ITEM che racchiude gli oggetti item delle superfici per applicare 
	le trasformazioni spaziali */
	ITEM list ;
} occhi ;

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
occhi* new_occhi( char *name , char *path , ITEM *int_attr , ITEM *ext_attr ) ;

/* ********************************************************************************************
IMPLEMENTAZIONE 
********************************************************************************************* */

#include "../../../common/utilities.e" /* concat */

#include <stdio.h> /* fprintf */
#include <stdlib.h> /* malloc , exit */
#include <string.h> /* strdup */

/* funzione che crea una nuova struttura e la restituisce , bisogna inserire il nome 
da dare alla struttura e il path che va dal programma effettivo alla libreria */
occhi* new_occhi( char *name , char *path , ITEM *int_attr , ITEM *ext_attr ) {
	/* controllo i valori di input */
	if (( name == NULL ) || ( path == NULL ) || ( int_attr == NULL ) || ( ext_attr == NULL )) {
		fprintf( stderr , "valori di input non validi\n" ) ;
		exit( EXIT_FAILURE ) ;
	} else {
		/* alloco memoria alla struttura */
		occhi* new ;
		new = malloc( sizeof ( occhi )) ;
		if ( new == NULL ){
			fprintf( stderr , "impossibile allocare ulteriore memoria\n" ) ;
			exit( EXIT_FAILURE ) ;
		}
		/* ricavo le superfici */
		new->occhio_bulbo_dx = get_surface( path_occhio_bulbo_dx , path ) ;
		new->occhio_bulbo_sx = get_surface( path_occhio_bulbo_sx , path ) ;
		new->occhio_dx = get_surface( path_occhio_dx , path ) ;
		new->occhio_sx = get_surface( path_occhio_sx , path ) ;
		/* collego le superfici agli attributi */
		set_attribute( *(new->occhio_bulbo_dx) , *int_attr);
		set_attribute( *(new->occhio_bulbo_sx), *int_attr);
		set_attribute( *(new->occhio_dx), *ext_attr);
		set_attribute( *(new->occhio_sx), *ext_attr);
		{
			/* costruisco il nome da dare alla lista */
			char* name_lista ;
			name_lista = concat( "lista" , name , "_" ) ;
			/* costruisco la lista di raggruppamento */
			new->list = create_list( *(new->occhio_bulbo_dx ), name_lista ) ;
			new->list = insert_in_list( new->list , *(new->occhio_bulbo_sx) ) ;
			new->list = insert_in_list( new->list , *(new->occhio_dx) ) ;
			new->list = insert_in_list( new->list , *(new->occhio_sx) ) ;
		}
		/* restituisco l' oggetto */
		return new ;
	}
}

#endif 
